unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    Button2: TButton;
    Button3: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button4: TButton;
    Label4: TLabel;
    Edit1: TEdit;
    Label5: TLabel;
    Button5: TButton;
    Button6: TButton;
    Label6: TLabel;
        function lies_n:integer; //Von Hand eingetippt

    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

const B =224; //Ascii ohne Steuerzeichen
      BB=B*B; //Berechnet schon der Compiler
var
  Form1: TForm1;

implementation

{$R *.DFM}

function fPlusNmodBB(x,n:integer):integer;
  //Hier knnte auch eine beliebige umkehrbare Funktion
  //mit dem Definitionsbereich {0,1,2,...,BB-1} stehen
  //z.B. der RSA-Algorithmus x->x^n mod BB
  //     die Umkehrfunktion ist dann aber nicht mehr mit -n zu bewerkstelligen
  //     sondern nur wenn die Zerlegung A=P1*P2 einer gewissen Zahl in
  //     ihre Primfaktoren P1 und P2 gelingt
begin
  result:=x+n;
  if result>=BB then result:=result-BB;
  if result<0   then result:=result+BB;
end;

procedure VerschlZweierBlock(var c1,c2:char; n:integer);
  var i:integer;
begin
  i:=fPlusNmodBB(ord(c1)-32+(ord(c2)-32)*B,n);
  //Funktion angewandt auf i von der Form i=a+b*B
  c1:=char(i mod B +32);  //mod wie Punkt- vor Strichrechnung
  c2:=char(i div B+32);   //div ist Punktrechnung: Keine Klammer ntig
end;

Procedure VerschlZeile(var s:string; n:integer);
  var k:integer;
begin
  if length(s) mod 2 <> 0 then s:=s+' '; //Lnge gerade Zahl
  for k:=1 to length(s) div 2 do
    VerschlZweierBlock(s[2*k-1],s[2*k],n); //Fr k=1 s[1],s[2], fr k=2 s[3],s[4], ...
end;

Procedure VerschlMemo(const m1:Tmemo; var m2:Tmemo; n:integer);
  //const vor m1 spart Speicherplatz (lohnt sich hier):
  //Es wird keine neue Instanz erzeugt
  var i:integer;
      s:string;
begin
  m2.lines.clear;
  for i:=0 to m1.lines.count-1 do Begin
    s:=m1.lines[i];
    verschlZeile(s,n);
    m2.lines.add(s);
  End;
   m2.SelStart := 0; //Cursor an den Anfang
   m2.Perform(EM_SCROLLCARET, 0, 0); //Tricks machen das Leben schner
end;

function TForm1.lies_n:integer; //Von Hand eingetippt
begin
 try
    result:=StrtoInt(edit1.text);
  Except
    showmessage('Bitte geben sie fr n eine Zahl ein');
    result:=0;
    exit;
  End;
  result:=result mod BB;
  edit1.text:=intToStr(result);
end;




procedure TForm1.Button1Click(Sender: TObject);
  var n: integer;
begin
  n:=lies_n;
  VerschlMemo(memo1,memo2,n);
  memo3.lines.clear;
end;

procedure TForm1.Button2Click(Sender: TObject);
 var n: integer;
begin
  n:=lies_n;
  VerschlMemo(memo2,memo3,-n);
end;



procedure TForm1.Button4Click(Sender: TObject);
begin
close;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
 close
end;

procedure TForm1.Button6Click(Sender: TObject);
   //Text in String und zurck siehe TTW Men "Hilfsmittel|Export"
begin
  edit1.text:=IntToStr(random(BB));
  memo1.Text:='Unberhmte letzte Worte:'#13#10+
             '-------------------------'#13#10+
             'Nimm mein Feuerzeug und schaue nach,'#13#10+
             'ob noch Benzin im Tank ist!';
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  randomize; //wegen random
  form1.Align:=alClient; //Jetzt bin ich dran
  label6.caption:='0<n<'+intToStr(BB);
end;

end.
